area
	outside	// lay this area on the map anywhere you want it to change from night to day
		layer = 2000	// set this layer above everything else so the overlay obscures everything
		var
			lit = 1	// determines if the area is lit or dark.
			obj/weather/Weather	// what type of weather the area is having
		proc
			daycycle()
				overlays += 'black25.dmi'	// add a 25% dither for a fading effect
				world<<""
				world<<""
				world<<"It is getting dark"
				sleep(60)
				overlays -= 'black25.dmi'	// remove the dither
				overlays += 'black50.dmi'	// add the 50% dither
				world<<"It is getting darker"
				sleep(6000)
				overlays -= 'black50.dmi'	// add the 50% dither
				world<<"It is gets bright"
				sleep(6000)
				daycycle()	// change the 20 to make longer days and night

			SetWeather(WeatherType)
				if(Weather)	// see if this area already has a weather effect
					if(istype(Weather,WeatherType)) return	// no need to reset it
					overlays -= Weather	// remove the weather display
					del(Weather)	// destroy the weather object
				if(WeatherType)	// if WeatherType is null, it just removes the old settings
					Weather = new WeatherType()	// make a new obj/weather of the right type
					overlays += Weather	// display it as an overlay for the area

mob/Weather_controll/verb
	Heavy_rain()
		var/area/outside/O
		for(O in world)		// look for an outside area
			break
		if(!O) return	// if there are no outside areas, stop
		O.SetWeather(/obj/weather/rain)
	rain()
		var/area/outside/O
		for(O in world)		// look for an outside area
			break
		if(!O) return	// if there are no outside areas, stop
		O.SetWeather(/obj/weather/rain)
	Light_rain()
		var/area/outside/O
		for(O in world)		// look for an outside area
			break
		if(!O) return	// if there are no outside areas, stop
		O.SetWeather(/obj/weather/rain2)
	snow()
		var/area/outside/O
		for(O in world)		// look for an outside area
			break
		if(!O) return	// if there are no outside areas, stop
		O.SetWeather(/obj/weather/snow)
	Sand_Storm()
		var/area/outside/O
		for(O in world)		// look for an outside area
			break
		if(!O) return	// if there are no outside areas, stop
		O.SetWeather(/obj/weather/Sand_Storm)
	Blackout()
		var/area/outside/O
		for(O in world)		// look for an outside area
			break
		if(!O) return	// if there are no outside areas, stop
		O.SetWeather(/obj/weather/blackout)
	clear_weather()
		var/area/outside/O
		for(O in world)		// look for an outside area
			break
		if(!O) return	// if there are no outside areas, stop
		O.SetWeather()
	daycycle()
		var/area/outside/O
		for(O in world)		// look for an outside area
			O.daycycle()



obj/weather
	layer = 2000	// weather appears over the darkness because I think it looks better that way
	Sand_Storm
		icon = 'weather.dmi'
		icon_state = "storm"
	rain
		icon = 'weather.dmi'
		icon_state = "Rain"
	rain2
		icon = 'weather.dmi'
		icon_state = "LRain"
	snow
		icon = 'weather.dmi'
		icon_state = "Snow"
	blackout
		icon = 'weather.dmi'
		icon_state = "black"